/* ScummVM - Graphic Adventure Engine
 *
 * ScummVM is the legal property of its developers, whose names
 * are too numerous to list here. Please refer to the COPYRIGHT
 * file distributed with this source distribution.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *

 *
 */



enum InputSimulation {
	kEscDown = 0,
	kEscUp,
	kMouseMove,
	kClickDown,
	kClickUp,
	kKeyDown,
	kKeyUp,
	kEnterDown,
	kEnterUp
};

enum InputSimulationGob23 {
	kEscDown1 = 0,
	kEscUp1,
	kWaitIntro,
	kMoveMouse,
	kLaunchLoad
};

enum saveSimulation {
	kSaveMove = 0,
	kSaveLD ,
	kSaveLU,
	kSaveT,
	kSaveAD,
	kSaveAU,
	kSaveED,
	kSaveEU
};

enum loadSimulation {
	kLoadMove = 0,
	kLoadLD,
	kLoadLU,
	kLoadT,
	kLoadSlot,
	kLoadED,
	kLoadEU
};

enum ScreenOrientation {
	kScreenOrientationPortrait,
	kScreenOrientationLandscape,
	kScreenOrientationFlippedLandscape
};

typedef enum
{
	kUIViewSwipeUp = 1,
	kUIViewSwipeDown = 2,
	kUIViewSwipeLeft = 4,
	kUIViewSwipeRight = 8
} UIViewSwipeDirection;


