#ifndef _BUTTON_H
#define _BUTTON_H

#include "common/rect.h"
#include "graphics/surface.h"
#include "backends/platform/android/texture.h"

class Button {

private:
	Common::Rect _currentGlobalBound;
	Common::Rect _staticGlobalBound;
	Graphics::Surface *_surface;
	GLESBaseTexture *_texture;
	unsigned int centerX;
	unsigned int centerY;
	float scaleX;
	float scaleY;
	
public:
	Button() : _texture(0) {}
	void initTexture();
	bool isClicked(int x,int y){ return _currentGlobalBound.contains(x,y);}
	void updateBuffer(){	_texture->updateBuffer(0,0,_surface->w,_surface->h,_surface->pixels,_surface->pitch);}
	void display() ;
	void setFilter(bool filter){_texture->setLinearFilter(filter);}
	void setCenter(unsigned int x, unsigned int y){ centerX=x;centerY=y;}
	void setScale(float scalex,float scaley){ debugdot("button.h :: scalex , scaley = %f,%f",scalex,scaley);scaleX=scalex;scaleY=scaley;}
	void setSurface(Graphics::Surface * surf){ _surface=surf;}
	void setBoundToNull(){ _currentGlobalBound=Common::Rect(0,0,0,0);}
	void release();
	void reinit();

};


#endif
