#ifndef MENUIG_H
#define MENUIG_H

#include "backends/platform/android/texture.h"
#include "backends/fs/fs-factory.h"
#include "common/rect.h"
#include "graphics/surface.h"
#include "graphics/decoders/bmp.h"

class MenuIG {
	private:
		GLESBaseTexture *_menu_texture;
		GLESBaseTexture *_resume_texture;
		GLESBaseTexture *_load_texture;
		GLESBaseTexture *_restart_texture;
		GLESBaseTexture *_setting_texture;
		GLESBaseTexture *_leave_texture;

		Graphics::BitmapDecoder _bmpMenu;
		Graphics::BitmapDecoder _bmpResume;
		Graphics::BitmapDecoder _bmpLoad;
		Graphics::BitmapDecoder _bmpRestart;
		Graphics::BitmapDecoder _bmpSetting;
		Graphics::BitmapDecoder _bmpLeave;

		Graphics::Surface _bmpSurfaceMenu;
		Graphics::Surface _bmpSurfaceResume;
		Graphics::Surface _bmpSurfaceLoad;
		Graphics::Surface _bmpSurfaceRestart;
		Graphics::Surface _bmpSurfaceSetting;
		Graphics::Surface _bmpSurfaceLeave;

		Common::Rect _boundResume;
		Common::Rect _boundLoad;
		Common::Rect _boundRestart;
		Common::Rect _boundSetting;
		Common::Rect _boundLeave;
	public :
		void loadImage(FilesystemFactory* fsfactory);
		void show();
		int contains(int x, int y); // return the value of menu clic : 0 for resume , 1 for load, 2 for restart, 3 for option and 4 for leave
};	

#endif 
