#ifndef _TEXTBUTTON_H
#define _TEXTBUTTON_H

#include "common/rect.h"
#include "backends/platform/android/dotemubmpfont.h"
#include "backends/platform/android/texture.h"

class TextButton {

private:
	Common::Rect _currentGlobalBound;
	
	dotemuBmpFont *_font;
	GLESBaseTexture *_texture;
	unsigned int x;
	unsigned int y;
	
	/*float scaleX;
	float scaleY;*/
	
public:
	TextButton() : _texture(0){}
	void initTexture();
	bool isClicked(int x,int y){ return _currentGlobalBound.contains(x,y);}
	void setCenter(unsigned int posx,unsigned int posy){ x=posx; y=posy;}
	//void updateBuffer(){	_texture->updateBuffer(0,0,_surface->w,_surface->h,_surface->pixels,_surface->pitch);}
	//void display() ;
	
	//void setScale(float scalex,float scaley){ debugdot("button.h :: scalex , scaley = %f,%f",scalex,scaley);scaleX=scalex;scaleY=scaley;}
	void setFont(dotemuBmpFont* font){ _font=font;}
	void setBoundToNull(){ _currentGlobalBound=Common::Rect(0,0,0,0);}
	void setFilter(bool filtre);
	unsigned int drawString(char* Str, float size,bool limited=0,bool black=0);
	void release(){
		if(_texture)
			_texture->release();
	}
	void reinit(){
		if(_texture)
			_texture->reinit();
	}
	
};


#endif
