package com.dotemu.gobliiins;

import com.dotemu.gobliiins.R;
import com.dotemu.googleLicensing.GoogleLicensing;
//import com.dotemu.neogeo.R;


import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.Environment;
import android.os.StrictMode;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.WindowManager.LayoutParams;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TextView;

public abstract class LaunchActivity 
extends Activity 
implements GameInstallerProgressListener
{
	public static StringsLoader strings = null;
	protected static GameInstaller gameInstaller = null;    
	private TextView txtPackageName = null;
	private TextView txtProgress = null;
	private ProgressBar progressBar = null;
	private boolean bInstallerRunning = false;
	private boolean bFirstResume = true;
	private boolean bErrorOccured = false;
	
	private boolean start = false;
	
	protected String gameDirectory;
	
	public static boolean STAND_ALONE_BUILD; // To set in GameLaunchActivity.java
	
	private native void apSetDataDirectory(String directory);
	protected native void nativeSetAPKPath(String apkPath, long size);
	
	// called from native code
	private static void loadStrings(String path) {
		strings = new StringsLoader(path);
	}
	
	public static boolean USE_FMOD = false;
	
	AlertDialog.Builder packageErrorBuilder;
	AlertDialog packageErrorAlert;
	
	public LaunchActivity() {
		super();

		/*try {
			if (LaunchActivity.USE_FMOD) {
				System.loadLibrary("fmodex");
			}
			System.loadLibrary("Emulator");
		}
		catch (UnsatisfiedLinkError e) {
			Log.i("LOAD LIB", "FAILED LOADING LIB LAUNCH ACTIVITY " + e);
		}*/
		
	}
    
	protected abstract void createGameInstaller(String apkPath);
	
	protected abstract Intent prepareNextActivity();

	protected abstract void setImageLogo(ImageView iv);

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);

		/*try {
			if (LaunchActivity.USE_FMOD) {
				System.loadLibrary("fmodex");
			}
			System.loadLibrary("Emulator");
			start = true;
		}
		catch (UnsatisfiedLinkError e) {
			Log.i("LOAD LIB", "FAILED LOADING LIB LAUNCH ACTIVITY " + e);
			start = false;
			
			//TODO: Send device info to DotEmu
			
			AlertDialog.Builder builder = new AlertDialog.Builder(this);
			builder.setMessage("An error occured. Your device might be incompatible with the game.\nPlease contact support@dotemu.com to get a refund.")
			.setCancelable(false)
			.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					System.exit(0); // Force exit
				}
			});
			builder.show();
		}*/
		start = true;
		if(!start) return;
		
		// Create window and view
		LayoutParams windowLayoutParams = super.getWindow().getAttributes();
		windowLayoutParams.flags |= LayoutParams.FLAG_KEEP_SCREEN_ON | LayoutParams.FLAG_TURN_SCREEN_ON;
		super.getWindow().setAttributes(windowLayoutParams);
		
		ApplicationInfo appInfo = null;
        PackageManager packMgmr = getApplication().getPackageManager();
        try {
            appInfo = packMgmr.getApplicationInfo(getApplication().getPackageName(), 0);
        } catch (NameNotFoundException e) {
            e.printStackTrace();
            throw new RuntimeException("Unable to locate assets, aborting...");
        }
        
        String apkPath = appInfo.sourceDir;
		bInstallerRunning = false;		
		gameDirectory = Environment.getExternalStorageDirectory()+"/Android/data/"+getPackageName()+"/files";

		createGameInstaller(apkPath);
		
		
		final String message = this.getString(R.string.DOWNLOAD_ERROR);
		packageErrorBuilder = new AlertDialog.Builder(LaunchActivity.this);
		packageErrorBuilder.setMessage(message)
		.setCancelable(false)
		.setNeutralButton(R.string.ok, new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) { bErrorOccured = true; }
		});
		
		packageErrorAlert  = packageErrorBuilder.create();
		
	}
	
	@Override
	public void onWindowFocusChanged(boolean hasFocus) {
		if(hasFocus && bErrorOccured) {
			System.exit(0);
		}
		
		super.onWindowFocusChanged(hasFocus);
	}

	@Override
	public void onResume()
	{
		super.onResume();
		
		if(!bFirstResume) return;
		else bFirstResume = false;
		
		if (gameInstaller!=null)
		{
			if (!bInstallerRunning)
			{
				// Check SD-Card state before anything
				runOnUiThread(new Runnable()
				{
					public final void run()
					{
						gameInstaller.checkSdCard();
						if (gameInstaller.checkGameInstallation()==false)
						{
							setContentView(R.layout.launch);
							txtPackageName = (TextView)findViewById(R.id.txtPackageName);
							txtProgress = (TextView)findViewById(R.id.txtProgress);
							progressBar = (ProgressBar)findViewById(R.id.progressBar1);
							ImageView iv = (ImageView)findViewById(R.id.logoView);
							setImageLogo(iv);
							
							WifiManager wfm = (WifiManager)LaunchActivity.this.getSystemService(Context.WIFI_SERVICE);
							WifiInfo wfi = null;
							String ssid = null;
							boolean bWifi = wfm.isWifiEnabled();
							if (bWifi)
							{
								wfi = wfm.getConnectionInfo();
								if (wfi!=null)
								{
									ssid = wfi.getSSID();
								}
							}
							
							if(STAND_ALONE_BUILD)
							{
								bInstallerRunning = true;
								gameInstaller.execute((String[])null);
							}
							else 
							{
								if ((!bWifi) || (wfi==null) || (ssid==null))
								{
										try
										{
											final int message = R.string.DOWNLOAD_PROMPT;
											runOnUiThread( new Runnable() { public final void run() { 	
												AlertDialog.Builder builder = new AlertDialog.Builder(LaunchActivity.this);
												builder.setMessage(message)
												.setCancelable(false)
												.setPositiveButton(R.string.yes, new DialogInterface.OnClickListener() {
													public void onClick(DialogInterface dialog, int id) {
														// initiate APK expansion URL fetch
														if(GoogleLicensing.enableGoogleLVL) GoogleLicensing.FetchApkPolicy(LaunchActivity.this);
														
														bInstallerRunning = true;
														gameInstaller.execute((String[])null);
													}
												})
												.setNegativeButton(R.string.no, new DialogInterface.OnClickListener() {
													public void onClick(DialogInterface dialog, int id) {
														LaunchActivity.this.finish();
													}
												});
												final AlertDialog alert = builder.create();
												alert.show(); 
											} });
										} catch (Exception e) {}
									}
								else
								{
									// WiFi network connected
									
									// initiate APK expansion URL fetch
									if(GoogleLicensing.enableGoogleLVL) GoogleLicensing.FetchApkPolicy(LaunchActivity.this);
									
									bInstallerRunning = true;
									gameInstaller.execute((String[])null);
								}
							}
						}
						else
						{
							launchNextActivity();
						}
					}
				});
			}
		}
	}

	@Override
	protected void onPause() 
	{
		super.onPause();
		if (isFinishing())
		{
			if (gameInstaller!=null)
			{
				if (bInstallerRunning)
				{
					gameInstaller.cancel(true);
					bInstallerRunning = false;
				}
			}
		}
	}

	@Override
	public void onStop()
	{
		super.onStop();
		System.gc();
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) 
	{
		if (keyCode == KeyEvent.KEYCODE_BACK) 
		{
			this.finish();
			return true;
		}
		return true;
	}

	@Override
	public boolean onKeyUp(int keyCode, KeyEvent event) 
	{
		return true;
	}

	@Override
	public boolean onTrackballEvent (MotionEvent event)
	{
		return true;
	}

	public void updateProgressBar(final int percent)
	{
		runOnUiThread(new Runnable()
		{
			public final void run()
			{
				int p = percent;
				if (p > 100) p = 100;
				else if (p < 0) p = 0;
				if (p != progressBar.getProgress())
				{
					progressBar.setProgress(p);
				}
			}
		});
	}

	public void updatePackageName(final String text)
	{
		runOnUiThread(new Runnable()
		{
			public final void run()
			{
				txtPackageName.setText(text);
			}
		});
	}

	public void updateProgressText(int resId)
	{
		final String text = getString(resId);
		runOnUiThread(new Runnable()
		{
			public final void run()
			{
				txtProgress.setText(text);
			}
		});
	}

	public void updateProgressText(final String text)
	{
		runOnUiThread(new Runnable()
		{
			public final void run()
			{
				txtProgress.setText(text);
			}
		});
	}

	public void launchNextActivity()
	{
		DisplayMetrics metrics = new DisplayMetrics();
		getWindowManager().getDefaultDisplay().getMetrics(metrics);
		
		// cocosdenshion
		// Cocos2dxMusic.resourcePath = gameDirectory;
		
		// neogeo
       // apSetDataDirectory(gameDirectory);
        
        // cocos2dx
        //nativeSetPaths(gameDirectory);
		
		runOnUiThread(new Runnable()
		{
			public final void run()
			{
				if (!bErrorOccured)
				{
					Intent i = prepareNextActivity();					
					LaunchActivity.this.startActivity(i);
				}
				LaunchActivity.this.finish();
			}
		});
	}

	private int packageSize = 0;

	public void onPackageBegin(String name, int size) 
	{
		String currentPackage = this.getString(R.string.CURRENT_PACKAGE);
		updatePackageName(currentPackage+" : "+name+" ("+size/1024+" KB)");
		packageSize = size;
	}

	public void onPackageDownload(int bytes) 
	{
		String downloading = this.getString(R.string.downloading);
		updateProgressText(downloading+" : "+(bytes/1024)+" KB...");
		if (packageSize>0)
			updateProgressBar((int)(((long)bytes)*100/((long)packageSize)));
	}

	public void onPackageVerify() 
	{
		String verifyPackage = this.getString(R.string.VERIFY);
		updateProgressText(verifyPackage);
	}

	public void onPackageUnpack(String file, int percent) 
	{
		String unpacking = this.getString(R.string.UNPACKING);
		updateProgressText(unpacking+" : "+file);
		updateProgressBar(percent);
	}

	public void onPackageError(String name, int errorNumber) 
	{
		try
		{
			//final String message = this.getString(R.string.DOWNLOAD_ERROR);
			runOnUiThread( new Runnable() { public final void run() { 	
				/*final AlertDialog.Builder builder = new AlertDialog.Builder(LaunchActivity.this);
				builder.setMessage(message)
				.setCancelable(false)
				.setNeutralButton(R.string.ok, new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) { bErrorOccured = true; }
				});*/
				if( !(LaunchActivity.this).isFinishing())
				{
					packageErrorAlert.show(); 
				}
			} });
		} catch (Exception e) {}

		try
		{
			gameInstaller.cancel(true);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public void onPackageDone(String name) 
	{
		String finishing = this.getString(R.string.FINISHING_PACKAGE);
		updateProgressText(finishing+" : "+name);	
	}

	public void onNoFreeSpaceError(int mb)
	{
		try {
			runOnUiThread( new Runnable() { public final void run() { 	
				AlertDialog.Builder builder = new AlertDialog.Builder(LaunchActivity.this);
				builder.setMessage(R.string.NO_SPACE)
				.setCancelable(false)
				.setNeutralButton(R.string.ok, new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) { bErrorOccured = true; }
				});
				final AlertDialog alert = builder.create();
				alert.show(); 
			} });
		} catch (Exception e) {}
		
		try
		{
			if (gameInstaller!=null)
				gameInstaller.cancel(true);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public void onSdCardError(String errorState) 
	{
		try {
			runOnUiThread( new Runnable() { public final void run() { 	
				AlertDialog.Builder builder = new AlertDialog.Builder(LaunchActivity.this);
				builder.setMessage(R.string.UNMOUNT_MEDIA)
				.setCancelable(false)
				.setNeutralButton(R.string.ok, new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) { bErrorOccured = true; }
				});
				final AlertDialog alert = builder.create();
				alert.show(); 
			} });
		} catch (Exception e) {}

		try
		{
			if (gameInstaller!=null)
				gameInstaller.cancel(true);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public void onNoInternetError()
	{
		if(!STAND_ALONE_BUILD)
		{
			try {
				runOnUiThread( new Runnable() { public final void run() { 	
					AlertDialog.Builder builder = new AlertDialog.Builder(LaunchActivity.this);
					builder.setMessage(R.string.NO_CONNECTION)
					.setCancelable(false)
					.setNeutralButton(R.string.ok, new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int id) { bErrorOccured = true; }
					});
					final AlertDialog alert = builder.create();
					alert.show(); 
				} });
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
		
		try
		{
			gameInstaller.cancel(false);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public void onInstallFinished(boolean bInstallOccured)
	{
		boolean installed = gameInstaller.checkGameInstallation();
		
		// Kill Game Installer
		if (gameInstaller != null)
		{
			gameInstaller = null;
			System.gc();
		}
		
		if(installed) launchNextActivity();
	}
	
	@Override
	public void onDestroy() {
		super.onDestroy();

		if(packageErrorAlert != null)
			packageErrorAlert.dismiss();
	}
}


